
class DataGraph:

    def __init__(self, proto_desc, type):
        self._graph = proto_desc
        self.type = type

    def get_parents(self, node):
        parents = []
        for edge in self._graph.edges:
            for child in edge.childs:
                if child == node:
                    parents.append(edge.parent)
        return parents

    def get_childs(self, node):
        for edge in self._graph.edges:
            if edge.parent == node:
                return edge.childs
        return []


    """
    @staticmethod
    def generate_tracks(data_graph):
        # sort nodes by time of first node (is in key), as list here
        time_sorted_nodes = list(sorted(data_graph._graph.edges, key=lambda item: item.parent.time))

        wave_id_per_node = [None] * len(time_sorted_nodes) # TODO rename stuff, not only wave id
        cur_id = 0

        # iterate over all time sorted identified connections
        # search temporal downstream tracked troughs and group them using a set id
        for con_idx, oc in enumerate(time_sorted_nodes):

            if wave_id_per_node[con_idx] is not None:  # already part of a wave
                continue

            # not part of wave -> get (temporal) downstream connections = wave (return indices of them)
            downstream_wave_node_indices = DataGraph.get_downstream_node_indices(time_sorted_nodes, con_idx)

            # any of downstream nodes already part of a wave?
            connected_wave_id = None
            for ds_node_idx in downstream_wave_node_indices:
                if wave_id_per_node[ds_node_idx] is not None:
                    # if connected_wave_id is not None:
                    #     print("Double ID, better resolve") # TODO
                    connected_wave_id = wave_id_per_node[ds_node_idx]

            # if so set all nodes to this found id
            if connected_wave_id is not None:
                for ds_node_idx in downstream_wave_node_indices:
                    wave_id_per_node[ds_node_idx] = connected_wave_id
                continue

            # else new path for all wave_nodes
            cur_id_needs_update = False
            for ds_node_idx in downstream_wave_node_indices:
                wave_id_per_node[ds_node_idx] = cur_id
                cur_id_needs_update = True

            if cur_id_needs_update:
                cur_id += 1

        # done, now extract every wave by id and put them into subgraphs
        track_graphs = []

        for wave_id in range(cur_id):
            track = data_graph.type.ObjectGraph()
            wave_idxs = [i for i in range(len(wave_id_per_node)) if wave_id_per_node[i] == wave_id]

            cur_wave_nodes = [time_sorted_nodes[i] for i in wave_idxs]  # troughs of this wave
            # cur_troughs = cur_troughs.sortbytime # already sorted?
            track.edges.extend(cur_wave_nodes)
            track_graph = DataGraph(track, data_graph.type)
            track_graphs.append(track_graph)

        print("Generated tracks for current set: " + str(len(track_graphs)))
        return track_graphs

    @staticmethod
    def get_downstream_node_indices(graph_list, start_idx):
        node_indices = [start_idx]

        co = graph_list[start_idx]
        node, connected_nodes = co.parent, co.childs

        for c_node in connected_nodes:
            # get index of connected node in graph
            obj_node_list = [con_.parent for con_ in graph_list]  # this up
            c_node_idx = obj_node_list.index(c_node)

            # call recursively on this connected node
            c_node_downstream_indices = DataGraph.get_downstream_node_indices(graph_list, c_node_idx)
            node_indices.extend(c_node_downstream_indices)

        return list(set(node_indices))
    """